From bd313d5e926ba4a81eabe364cc93fc20c3d310b8 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 23 2021 02:23:51 +0000
Subject: [PATCH 2157/2232] Add dedicated error message for ptr to ptr and ref to ptr


---

diff --git a/syntax/check.rs b/syntax/check.rs
index eba6565..a4cddfa 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -222,11 +222,15 @@ fn check_type_ref(cx: &mut Check, ty: &Ref) {
     }
 
     match ty.inner {
-        Type::Fn(_) | Type::Void(_) | Type::Ptr(_) => {}
+        Type::Fn(_) | Type::Void(_) => {}
         Type::Ref(_) => {
             cx.error(ty, "C++ does not allow references to references");
             return;
         }
+        Type::Ptr(_) => {
+            cx.error(ty, "support for reference to pointer is not implemented yet");
+            return;
+        }
         _ => return,
     }
 
@@ -235,11 +239,15 @@ fn check_type_ref(cx: &mut Check, ty: &Ref) {
 
 fn check_type_ptr(cx: &mut Check, ty: &Ptr) {
     match ty.inner {
-        Type::Ptr(_) | Type::Fn(_) | Type::Void(_) => {}
+        Type::Fn(_) | Type::Void(_) => {}
         Type::Ref(_) => {
             cx.error(ty, "C++ does not allow pointer to reference as a type");
             return;
         }
+        Type::Ptr(_) => {
+            cx.error(ty, "support for pointer to pointer is not implemented yet");
+            return;
+        }
         _ => return,
     }
 
diff --git a/tests/ui/ptr_unsupported.stderr b/tests/ui/ptr_unsupported.stderr
index e037faa..af5e134 100644
--- a/tests/ui/ptr_unsupported.stderr
+++ b/tests/ui/ptr_unsupported.stderr
@@ -1,4 +1,4 @@
-error: unsupported pointer type
+error: support for pointer to pointer is not implemented yet
  --> $DIR/ptr_unsupported.rs:6:32
   |
 6 |         fn get_ptr_to_ptr() -> *mut *mut C;
@@ -10,7 +10,7 @@ error: C++ does not allow pointer to reference as a type
 7 |         fn get_ptr_to_reference() -> *mut &C;
   |                                      ^^^^^^^
 
-error: unsupported reference type
+error: support for reference to pointer is not implemented yet
  --> $DIR/ptr_unsupported.rs:8:38
   |
 8 |         fn get_reference_to_ptr() -> &*mut C;

